# Create the Flexsim menu
menubutton .mbar.flexsim -text "Flexsim" -menu .mbar.flexsim.menu -underline 0
menu .mbar.flexsim.menu -tearoff 0
$m add cascade -menu .mbar.flexsim.menu -label "Flexsim" -underline 3


# Global variable to record how many colors to copy
# I use this because AC3D doesn't give a way to get the number of materials available
set .numcolors 0

# Copy the Diffuse color to the Ambient color for the first N materials
proc ajsetamb { } {
	upvar #0 .numcolors numcolors
	
	puts "Number of Materials $numcolors"

	for {set entry 0} {$entry < $numcolors} {incr entry} {
		puts "Material $entry"
     
		set mat [ac3d palette_get_material $entry]
		
		# get the diffuse
		set dif [ ac3d entity_get_value $mat diffuse]
		
		# get the ambient and convert to 0-255 values - check for color-changable
		set amb [ ac3d entity_get_value $mat ambient]
		set i 0
		foreach x $amb {
			lset amb $i [expr round( {$x * 255} )]
			incr i
		}
		puts "   ambient: $amb"
		if {[lindex $amb 0] != 60 && [lindex $amb 1] != 60 && [lindex $amb 2] != 62} {
			puts "Copy its diffuse"
			# set to ambient
			ac3d entity_set_value $mat ambient $dif
		} else {
			puts "Skip it"
		}
	}
}
 
# Set the number of materials to edit - connected to the slider
proc setnumcolors { value } {
	puts "Changed num colors: $value"
	upvar .numcolors numcolors
	set numcolors $value
}

# Create a small GUI to run everything - connected to the menu
proc ambientsetter { } {
	set t .ajambient
	new_toplevel $t "Diffuse To Ambient"

	scale $t.numcolors  -label "Number of Colors" -from 1 -to 50 -length 5c -orient horizontal  -resolution 1 \
			-command { setnumcolors }
	pack $t.numcolors

	button $t.b -text "Copy Diffuse Colors" -command ajsetamb
	pack $t.b
	
	label $t.t -text "Note: Skips color (60,60,62)/(.235,.235,.243)"
	pack $t.t
	
	centre_window_on_screen $t
}

#Add to the Flexsim menu
.mbar.flexsim.menu add command -label "Copy Diffuse Colors" -command ambientsetter -underline 0